import java.awt.*;
import java.awt.event.*;

public class MainFrame extends Frame
{
    private static final byte DRAW_BUTTON = 21;
    private static final byte EXIT_BUTTON = 20;

    public NoverKCanvas myCanvas = new NoverKCanvas();
    Panel workPanel = new Panel();
    Button drawButton = new Button("Draw");
    Button exitButton = new Button("Exit!");

    private boolean mShown = false;
    public boolean pressed = false;
    public byte buttonNr;

    public MainFrame()
    {
	setBackground(new Color(170,170,170));
	setResizable(false);
    }
    
    public void initComponents() throws Exception
    {
	myCanvas.setSize(new Dimension(NoverKCanvas.width/*512*/, NoverKCanvas.height/*512*/));
	myCanvas.setVisible(true);
	myCanvas.setLocation(new Point(10, 10));
	
	workPanel.setSize(new Dimension(120, NoverKCanvas.height/*512*/));
	workPanel.setLocation (new Point(NoverKCanvas.width+18/*530*/, 10));
	workPanel.setBackground(Color.lightGray);
	workPanel.setVisible(true);

	drawButton.setSize(new Dimension(80, 20));
	drawButton.setVisible(true);
	drawButton.setLocation(new Point(NoverKCanvas.width+38/*550*/, 422));
	
	exitButton.setSize(new Dimension(80, 20));
	exitButton.setVisible(true);
	exitButton.setLocation(new Point(NoverKCanvas.width+38/*550*/, 482));
	
	setSize(new Dimension(NoverKCanvas.width+149/*661*/, NoverKCanvas.height+49/*561*/));
	setLayout(null);
	setTitle("The relative error between 2N over N and the approximated value");
	setLocation(new Point(0, 0));

      	add(myCanvas);
	add(drawButton);
	add(exitButton);
	add(workPanel);

    	drawButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		drawButtonActionPerformed(e);
	    }
	});

    	exitButton.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		exitButtonActionPerformed(e);
	    }
	});

	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		thisWindowClosing(e);
	    }
	});
    }
    
    public void addNotify() 
    {
	super.addNotify();
	
	if (mShown)
	    return;
	
	// move components to account for insets
	Insets insets = getInsets();
	Component[] components = getComponents();
	for (int i = 0; i < components.length; i++) {
	    Point location = components[i].getLocation();
	    location.move(location.x, location.y + insets.top);
	    components[i].setLocation(location);
	}
	
	mShown = true;
    }
    
    // Close the window when the close box is clicked
    void thisWindowClosing(WindowEvent e)
    {
	buttonNr = EXIT_BUTTON;
        setVisible(false);
	dispose();
	System.exit(0);
    }
    
    public void drawButtonActionPerformed(ActionEvent e)
    {
      buttonNr = DRAW_BUTTON;
      myCanvas.computeFunction();
      myCanvas.drawFunction();
    }

    public void exitButtonActionPerformed(ActionEvent e)
    {
	buttonNr = EXIT_BUTTON;
	setVisible(false);
	dispose();
	System.exit(0);
    }
}

